import "package:dart_irc/irc.dart";
import "package:dart_irc/model.dart";
import "package:dart_irc/callback.dart";

void main() {
  User user = new User("virginia_ave", "virginia_ave");
  Server server = new Server("freenode", "irc.freenode.net", 6667);
  Connection connection = new Connection(user, server, new IrcCallback());
  connection.connect();
}

class IrcCallback extends CallbackAdapter {
  @override
  void onConnect(Connection connection) {
    print("Connected");
    connection.join("#clojure");
  }

  @override
  void onMessage(Connection connection, String message) {
    // TODO streamline ping/pong stuff
    if (message.startsWith("PING"))
      connection.pong(message);
    print("[in] ${message}");
  }

  @override
  void onJoin(Connection connection, User user, Channel channel) {
    print("${user.nickname} joined ${channel.name}");
  }

  @override
  void onQuit(Connection connection, User user, String reason) {
    print("${user.nickname} quit because ${reason}");
  }

  @override
  void onDisconnect(Connection connection) {
    print("Disconnected");
  }
}